/**
  ******************************************************************************
  * @file    vk1088.c
  * @author  kevin_guo
  * @version V1.2
  * @date    05-17-2020
  * @brief   This file contains all the vk1088 functions. 
	*          ļ VK1088
  ******************************************************************************
  * @attention
  ******************************************************************************
  */	
/* Includes ------------------------------------------------------------------*/
#include "vk1088.h"
  
/* extern variables ----------------------------------------------------------*/
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define VK1088_CLK 10 //WRźƵ,delay_nusʵ 50->10kHz 10->50kHz 5->100kHz
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
//segtab[]ӦʵʵоƬLCDߣ߼-VK1088ο·
unsigned char vk1088_segtab[VK1088_SEGNUM]={
	0,1,2,3,4,5,6,7,8,9,						//SEG0-SEG9
	20,21,22,23,24,25,26,27,28,29,	//SEG20-SEG29
	30,31														//SEG30-SEG31
};
//LCDʵֻSEG20SEG31ʹ
//.hļVK1088_SEGNUM=12
//const unsigned char vk1088_segtab[VK1088_SEGNUM]={	
//	20,21,22,23,24,25,26,27,28,29,	//SEG20-SEG29
//	30,31,													//SEG30-SEG31
//};
//vk1088_dispramӦоƬʾRAM
unsigned char vk1088_dispram[VK1088_SEGNUM];
//Ӧvk1088_segtab[VK1088_SEGNUM]
//ʾRAM bufferֻʹõ4λbit0->com0,bit1->com1,bit2->com2,bit3->com3
//LCD ʵ  38
//1ǰλ2ʮλ3Ǹλ
/*ʾbufferlcdͼӳϵ
vk1088_dispram[VK1088_SEGNUM]=
{//com3   com2   com1     com0 //ӦоƬSEG  ӦʾRAM
	1D,     1E,    1F,      1A,     //seg8   			vk1088_dispram[8]
	  ,     1C,    1G,      1B,     //seg9				vk1088_dispram[9]
	2D,     2E,    2F,      2A,     //seg20				vk1088_dispram[10]	
	  ,     2C,    2G,      2B,     //seg21				vk1088_dispram[11]
	3D,     3E,    3F,      3A,		  //seg22				vk1088_dispram[12]
	  ,     3C,    3G,      3B,			//seg23				vk1088_dispram[13]
}
*/
/*8ֵ 
     A
   F   B
     G
	 E   C
	   D
*/
unsigned char shuzi_zimo[15]= //ַֺģ
{
//0    1    2    3    4    5    6    7    8    9    -    L    o    H    i 
	0xF5,0x05,0xD3,0x97,0x27,0xB6,0xF6,0x15,0xF7,0xB7,0x02,0xE0,0xC6,0x67,0x05
};
unsigned char vk1088_addrbit=6;//icramַA5-A0,
unsigned char vk1088_segi,vk1088_comi;
unsigned char vk1088_maxcom;//com4com3com2com
/* Private function prototypes -----------------------------------------------*/
/* Private function ----------------------------------------------------------*/
/*******************************************************************************
* Function Name  : delay_nus
* Description    : ʱ1uS
* Input          : n->ʱʱnuS
* Output         : None
* Return         : None
*******************************************************************************/
void delay_nus(unsigned int n)	   
{
	unsigned char i;
	while(n--)
	{
		i=10;
		while(i--)
		{//nopָݵƬӦ޸
			__nop();
		}
	}
}
/*******************************************************************************
* Function Name  : delay_nms
* Description    : ʱ1mS
* Input          : n->ʱʱnmS
* Output         : None
* Return         : None
*******************************************************************************/
void delay_nms(unsigned long int n)
{
	while(n--)
	{
		delay_nus(1000);
	}
}
/*******************************************************************************
* Function Name  : WriteClock
* Description    : WRʱ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void WriteClockVk1088(void)
{
	VK1088_WR_L(); 
	delay_nus(VK1088_CLK);
	VK1088_WR_H();	
	delay_nus(VK1088_CLK);	
}
/*******************************************************************************
* Function Name  : WriteCommand
* Description    : д
* Input          : FunctonCode->/ 
* Output         : None
* Return         : None
*******************************************************************************/
void WriteCommandVk1088(unsigned char FunctonCode)
{
	unsigned char Shift = 0x80; 
	unsigned char i;
	
	VK1088_CS_L();   //CS Ƭѡ   
	delay_nus(VK1088_CLK/2);
	VK1088_DATA_H();  
	WriteClockVk1088();
	VK1088_DATA_L();  
	WriteClockVk1088();
	VK1088_DATA_L();  
	WriteClockVk1088();

	for(i = 0; i < 8; i++) 
	{
	 if(Shift & FunctonCode) 	
		 VK1088_DATA_H(); 
	 else 
		 VK1088_DATA_L();	  

	 WriteClockVk1088();
	 Shift = Shift >> 1;
	}
  VK1088_DATA_L(); 
	WriteClockVk1088();	//һ0һλ X
  VK1088_CS_H(); 			//CS Ƭѡ  
	delay_nus(VK1088_CLK/2);
  VK1088_DATA_H(); 
}

/*******************************************************************************
* Function Name  : Write1Data
* Description    : д1SEGݵʾRAMbit3-COM3 bit2-COM2 bit1-COM1 bit0-COM0
* Input          : Addr->дramĵַ  
* 							 : Databuf->дram(1ֽݵ4λЧ)  
* Output         : None
* Return         : None
*******************************************************************************/
void Write1DataVk1088(unsigned char Addr,unsigned char Dat)
{
	unsigned char i; 
	unsigned char Shift;
	
	Shift = 0x20; //θ3λ ֻ5λ
	
	VK1088_CS_L();  //CS Ƭѡ
	delay_nus(VK1088_CLK/2);

	VK1088_DATA_H();  
	WriteClockVk1088();  //101
	VK1088_DATA_L();  
	WriteClockVk1088();
	VK1088_DATA_H();  
	WriteClockVk1088();

	for( i = 0; i < vk1088_addrbit; i++) 
	{   		 
		if (Addr & Shift) 
			VK1088_DATA_H(); 		
		else  
			VK1088_DATA_L();
		WriteClockVk1088();		
		Shift = Shift >> 1; 
	}
  Shift = 0x01;
  for (i = 0; i < 4; i++) 
	{

		if( Dat & Shift) 
			VK1088_DATA_H();		 
   	else  
			VK1088_DATA_L();
		WriteClockVk1088();
		Shift = Shift << 1;
	}   
  VK1088_CS_H(); //CS Ƭѡ
	delay_nus(VK1088_CLK/2);	
  VK1088_DATA_H(); 
}
/*******************************************************************************
* Function Name  : WritenData
* Description    : дnSEGݵʾRAMbit3-COM3 bit2-COM2 bit1-COM1 bit0-COM0
* Input          : Addr->дramʼַ  
* 							 : Databuf->дramָ(ÿֽݵ4λЧ)  
* 							 : Cnt->дramݸ
* Output         : None
* Return         : None
*******************************************************************************/
void WritenDataVk1088(unsigned char Addr,unsigned char *Databuf,unsigned char Cnt)
{
	unsigned char i,j; 
	unsigned char Shift;
	unsigned char dataval; 
	
	VK1088_CS_L();   //CS Ƭѡ 
	delay_nus(VK1088_CLK/2);

	VK1088_DATA_H();  
	WriteClockVk1088();  //101
	VK1088_DATA_L();  
	WriteClockVk1088();
	VK1088_DATA_H();  
	WriteClockVk1088();

	Shift = 0x20;
	for( i = 0; i < vk1088_addrbit; i++) 
	{   		 
		if (Addr & Shift) 
			VK1088_DATA_H(); 		
		else  
			VK1088_DATA_L();
		WriteClockVk1088();		
		Shift = Shift >> 1; 
	}
	for (j = 0; j < Cnt; j++) 
	{
		Shift = 0x01;
		dataval=*Databuf++;
		for (i = 0; i < 4; i++) 
		{
			if( dataval & Shift) 
				VK1088_DATA_H();		 
			else  
				VK1088_DATA_L();
			WriteClockVk1088();
			Shift = Shift << 1;
		}   
	}
  VK1088_CS_H();   //CS Ƭѡ
	delay_nus(VK1088_CLK/2);	 
  VK1088_DATA_H(); 
}
/*******************************************************************************
* Function Name  : Vk1088_DisAll
* Description    : SEGʾͬһݣbit3-COM3 bit2-COM2 bit1-COM1 bit0-COM0
* 					     : 磺0x0fȫ 0x00ȫ 0x05 0x0a 0x03 
* Input          dat->дram(1ֽݵ4λЧ)  
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1088_DisAll(unsigned char dat)
{
	unsigned char segi;
	unsigned char dispram[32];
	
	for(segi=0;segi<32;segi++)
	{
		dispram[segi]=0x00;
	}
	for(segi=0;segi<10;segi++)
	{
		dispram[segi]=dat;
	}
	for(segi=20;segi<32;segi++)
	{
		dispram[segi]=dat;
	}
	WritenDataVk1088(0,dispram,32);//4bitַԶ1
}
/*******************************************************************************
* Function Name  : DisSegComOn
* Description    : 1(1seg1comӦʾ)
* Input          seg->Ӧseg  
* 		           com->Ӧcom  
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1088_DisSegComOn(unsigned char seg,unsigned char com)
{
		Write1DataVk1088(seg,(1<<com));
}
/*******************************************************************************
* Function Name  : DisSegComOff
* Description    : ر1(1seg1comӦʾ)
* Input          seg->Ӧseg  
* 		           com->Ӧcom  
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1088_DisSegComOff(unsigned char seg,unsigned char com)
{
		Write1DataVk1088(seg,~(1<<com));
}
/*******************************************************************************
* Function Name  : Enter_Standby
* Description    : ͹ģʽ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1088_Enter_Standby(void)
{	
	//ʹLCDOFFSYSDIS,ϵͳڵ͹״̬
	//ֻʹƬRCʱԴʱ,ʹϵͳ͹״̬
	WriteCommandVk1088(OSC_OFF);
	WriteCommandVk1088(DISP_OFF);
}
/*******************************************************************************
* Function Name  : Exit_Standby
* Description    : ˳͹ģʽ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1088_Exit_Standby(void)
{	
	//˳͹״̬vk1088
	WriteCommandVk1088(OSC_ON);
	WriteCommandVk1088(DISP_ON);
	WriteCommandVk1088(COM_1_3__4);vk1088_maxcom=4;	//1/3bias 4com
//	WriteCommandVk1088(COM_1_3__3);vk1088_maxcom=3;	//1/3bias 3com
//	WriteCommandVk1088(COM_1_3__2);vk1088_maxcom=2;	//1/3bias 2com
//	WriteCommandVk1088(COM_1_2__4);vk1088_maxcom=4;	//1/2bias 4com
//	WriteCommandVk1088(COM_1_2__3);vk1088_maxcom=3;	//1/2bias 3com
//	WriteCommandVk1088(COM_1_2__2);vk1088_maxcom=2;	//1/2bias 2com
}
/*******************************************************************************
* Function Name  : Lowlevel_Init
* Description    : ͨGPIO
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1088_Lowlevel_Init(void)
{
	//ͨߵƽͬӵƽת·
	//˺ݿͻƬӦ޸	
	GPIO_SetMode(VK1088_CS_PORT, VK1088_CS_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK1088_WR_PORT, VK1088_WR_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK1088_DAT_PORT, VK1088_DAT_PIN, GPIO_MODE_OUTPUT);	//ֻʾݿΪIO
		
	VK1088_CS_H();                 
	VK1088_WR_H();  
	VK1088_DATA_H(); 	
}
/*******************************************************************************
* Function Name  : Init
* Description    : ʼ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1088_Init(void)
{	
	//ܽøݿͻƬӦ޸
	Vk1088_Lowlevel_Init();
	//
	WriteCommandVk1088(OSC_ON);
	WriteCommandVk1088(DISP_ON);
	WriteCommandVk1088(COM_1_3__4);vk1088_maxcom=4;	//1/3bias 4com
//	WriteCommandVk1088(COM_1_3__3);vk1088_maxcom=3;	//1/3bias 3com com2/com1/com0
//	WriteCommandVk1088(COM_1_3__2);vk1088_maxcom=2;	//1/3bias 2com com1/com0
//	WriteCommandVk1088(COM_1_2__4);vk1088_maxcom=4;	//1/2bias 4com
//	WriteCommandVk1088(COM_1_2__3);vk1088_maxcom=3;	//1/2bias 3com com2/com1/com0
//	WriteCommandVk1088(COM_1_2__2);vk1088_maxcom=2;	//1/2bias 2com com1/com0
	//ϵĬ(δùܹرս͹)
//	WriteCommandVk1088(BUZZ_2KHZ);
//	WriteCommandVk1088(BUZZ_4KHZ);
//	WriteCommandVk1088(BUZZ_ON);
	WriteCommandVk1088(BUZZ_OFF);
	WriteCommandVk1088(IRQ_DIS);
	WriteCommandVk1088(TIMER_DIS);
	WriteCommandVk1088(WDT_DIS);
}
/*******************************************************************************
* Function Name  : disp_3num
* Description    : ʾ3λ
* Input          dat->3λ ʮ 
* Output         : None
* Return         : None
*******************************************************************************/
void disp_3num(unsigned int dat)
{		
	unsigned dat8;
	
	dat8=dat/100%10;	//ʾλ
	vk1088_dispram[8]=shuzi_zimo[dat8]>>4;
	vk1088_dispram[9]&=0xf8;
	vk1088_dispram[9]|=shuzi_zimo[dat8]&0x07;
	
	dat8=dat/10%10; 	//ʾʮλ
	vk1088_dispram[10]=shuzi_zimo[dat8]>>4;
	vk1088_dispram[11]&=0xf8;
	vk1088_dispram[11]|=shuzi_zimo[dat8]&0x07;
	
	dat8=dat%10;			//ʾλ
	vk1088_dispram[12]=shuzi_zimo[dat8]>>4;
	vk1088_dispram[13]&=0xf8;
	vk1088_dispram[13]|=shuzi_zimo[dat8]&0x07;
		
	if(dat<100)				//С100λʾ
	{
		vk1088_dispram[8]&=0xf0;
		vk1088_dispram[9]&=0xf8;
	}
	if(dat<10) 	//С10ʮλʾ
	{
		vk1088_dispram[10]&=0xf0;
		vk1088_dispram[11]&=0xf8;
	}
	//SEG11
//	Write1DataVk1088(8,vk1088_dispram[8]);
//	Write1DataVk1088(9,vk1088_dispram[9]);
//	Write1DataVk1088(20,vk1088_dispram[10]);
//	Write1DataVk1088(21,vk1088_dispram[11]);
//	Write1DataVk1088(22,vk1088_dispram[12]);
//	Write1DataVk1088(23,vk1088_dispram[13]);
	//SEGͶ
	WritenDataVk1088(8,&vk1088_dispram[8],2);
	WritenDataVk1088(20,&vk1088_dispram[10],4);
}	
/*******************************************************************************
* Function Name  : test_Main
* Description    : 
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1088_Main(void)
{	
	Vk1088_Init();
	Vk1088_DisAll(0x00);
	while(1)
	{
		Vk1088_DisAll(0x0f);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		Vk1088_DisAll(0x00);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		disp_3num(123);           //ʾ123
		delay_nms(3000);					//ʱ3S
		
		Vk1088_DisAll(0x00);			//LCDȫ
		for(vk1088_segi=0;vk1088_segi<VK1088_SEGNUM;vk1088_segi++)//seg
		{
			for(vk1088_comi=0;vk1088_comi<vk1088_maxcom;vk1088_comi++)//com
			{
				Vk1088_DisSegComOn(vk1088_segtab[vk1088_segi],vk1088_comi);	//LCD
				delay_nms(300);				//ʱ300mS
				Vk1088_DisAll(0x00);	//LCDȫ
			}
		}
		
		Vk1088_DisAll(0x0f);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		for(vk1088_segi=0;vk1088_segi<VK1088_SEGNUM;vk1088_segi++)//seg
		{
			for(vk1088_comi=0;vk1088_comi<vk1088_maxcom;vk1088_comi++)//com
			{
				Vk1088_DisSegComOff(vk1088_segtab[vk1088_segi],vk1088_comi);	//LCDر
				delay_nms(300);				//ʱ300mS
				Vk1088_DisAll(0x0f);	//LCDȫ
			}
		}
		delay_nms(1000);					//ʱ1S
		
		Vk1088_DisAll(0x00);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		Vk1088_Enter_Standby();		//͹ģʽ
		delay_nms(5000);					//ʱ5S
		
		Vk1088_Exit_Standby();		//˳͹ģʽ
	}
}
/************************END OF FILE****/
